INCLUDE include.asm

.CODE
	
Start:

WinMain proc
	LOCAL wc:WNDCLASSEX
	LOCAL hInstance:HINSTANCE
	LOCAL msg:MSG
		
	INVOKE GetModuleHandle, NULL
	mov hInstance, eax
		
	; Load cursor first
	xor ebx, ebx
	mov edi, OFFSET ClassName
	INVOKE LoadCursor, ebx, IDC_ARROW
	
	; Fill in WNDCLASSEX for RegisterClassEx
	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style, ebx
	mov wc.lpfnWndProc, OFFSET WndProc
	mov wc.cbClsExtra, ebx
	mov wc.cbWndExtra, ebx
	push hInstance
	pop wc.hInstance
	mov wc.hbrBackground, ebx;COLOR_WINDOW+2
	mov wc.lpszMenuName, ebx
	mov wc.lpszClassName, edi
	mov wc.hIcon, ebx
	mov wc.hIconSm, ebx
	mov wc.hCursor, eax

	; Register WNDCLASSEX
	INVOKE RegisterClassEx, ADDR wc

	; Create a window of type ClassName
	INVOKE GetSystemMetrics, SM_CXSCREEN
	push eax
	mov GlobRect.right, eax
	
	INVOKE GetSystemMetrics, SM_CYSCREEN
	pop ecx
	mov GlobRect.bottom, eax
	
	INVOKE CreateWindowEx,	ebx,\;WS_EX_TOPMOST,\			;Extended window style
				edi,\				;ClassName
				edi,\				;WindowName
				WS_POPUP or WS_VISIBLE,\	;Style
				ebx,\				;x position
				ebx,\				;y position
				ecx,\				;Width
				eax,\				;Height
				ebx,\				;ParentWindow (No parent)
				ebx,\				;Menu?
				hInstance,\			;Handle to instance associated with the window
				ebx				;lParam (optional)

	mov edi, eax ; Save HWND handle returned
	
	; Show window
	INVOKE ShowWindow, edi, SW_SHOWNORMAL

	; Update window, will send a WM_PAINT if updateregion is not empty, not if it is empty
	;INVOKE UpdateWindow, edi 

	lea esi, msg
	
ALIGN 16
mLoop:	INVOKE GetMessage, esi, ebx, ebx, ebx ; If hWnd is NULL, GetMessage retrieves messages for thread and any window
	test eax, eax
	jz die
	INVOKE TranslateMessage, esi
	INVOKE DispatchMessage, esi
	jmp mLoop
	
die:	INVOKE ExitProcess, eax

WinMain endp


WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL ps:PAINTSTRUCT
	LOCAL hDC:HDC
	
	.IF uMsg==WM_PAINT

		INCLUDE WM_PAINT.asm
		
	.ELSEIF uMsg==WM_ERASEBKGND
		
		mov eax, 1
		ret

	.ELSEIF uMsg==WM_KEYDOWN

		.IF wParam==VK_ESCAPE
			INVOKE PostMessage, hWnd, WM_CLOSE, 0, 0
		.ENDIF
	
	.ELSEIF uMsg==WM_CREATE
	
		INCLUDE WM_CREATE.asm
		
	.ELSEIF uMsg==WM_CLOSE
	
		INVOKE DestroyWindow, hWnd

	.ELSEIF uMsg==WM_DESTROY

		INCLUDE WM_DESTROY.asm
		
	.ELSE

		; Default Windows Procedure prosesserer alle wm beskjeder som vi ikke tar oss av
		INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam
		ret

	.ENDIF

	xor eax,eax
	ret

WndProc endp 


; Creates a 32 bits-per-pixel DIB section for direct drawing routines
; Returns 0 on failure, otherwise eax contains handle of dib
CreateCompatibleDibSection PROC dc:HDC, ppvBitsPtr:DWORD
	LOCAL bminfo:BITMAPINFO

	; Fill in bitmapinfo
	mov bminfo.bmiHeader.biSize, SIZEOF BITMAPINFOHEADER
	INVOKE GetSystemMetrics, SM_CXSCREEN
	mov bminfo.bmiHeader.biWidth, eax
	INVOKE GetSystemMetrics, SM_CYSCREEN
	neg eax ; create top down dib, not bottom up (make height signed)
	mov bminfo.bmiHeader.biHeight, eax
	mov bminfo.bmiHeader.biPlanes, 1
	mov bminfo.bmiHeader.biBitCount, 32
	mov bminfo.bmiHeader.biCompression, BI_RGB
	mov bminfo.bmiHeader.biSizeImage, 0
	mov bminfo.bmiHeader.biXPelsPerMeter, 0
	mov bminfo.bmiHeader.biYPelsPerMeter, 0
	mov bminfo.bmiHeader.biClrUsed, 0
	mov bminfo.bmiHeader.biClrImportant, 0
	
	; Create dibsection
	INVOKE CreateDIBSection, dc, ADDR bminfo, DIB_RGB_COLORS, ppvBitsPtr, NULL, 0
	ret
	
CreateCompatibleDibSection ENDP


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

; --------------------------------------------------------------------------------------
; x and y doesnt need special registers as they will be continually read from source buffer anyway
; it's important to keep x in ecx as this is the only trashable register that mul doesnt trash
; ecx = x	eax = y		ebx = color	esi = ScrWidth		edi = bitdataptr
align 4
PlotPixelRA PROC
	mul esi
	add eax, ecx
	mov [edi+eax*4], ebx
	ret
PlotPixelRA ENDP

; ---------------------------------------------------------
; ecx = x	eax = y
align 4
PlotPixelR PROC color:DWORD
	mov edx, SCREEN_WIDTH
	mul edx
	add eax, ecx
	mov edx, bitdataptr
	mov ecx, [esp+4]
	mov [edx+eax*4], ecx
	ret 4
PlotPixelR ENDP

; ---------------------------------------------------------
align 4
PlotPixel PROC x:DWORD, y:DWORD, color:DWORD
	mov eax, [esp+8]
	mov ecx, SCREEN_WIDTH
	mul ecx
	mov edx, bitdataptr
	mov ecx, [esp+4]
	add eax, ecx
	mov ecx, [esp+12]
	mov [edx+eax*4], ecx
	ret 12
PlotPixel ENDP
; ---------------------------------------------------------
align 4
FillRectangle PROC x:DWORD, y:DWORD, w:DWORD, h:DWORD, col:DWORD
	push esi
	push edi
	push ebx
	push ebp
	mov eax, [esp+24]
	mov ecx, SCREEN_WIDTH
	mov esi, [esp+20]	; esi = x
	mov edi, [esp+28]	; edi = width
	mov ebp, [esp+32]	; ebp = height
	mul ecx
	mov edx, [esp+36]
	add eax, esi
	mov esi, bitdataptr
	lea esi, [esi+eax*4]	; esi = startpix
	mov ebx, esi		; ebx =  copy of esi
	mov eax, edi
	shl ecx, 2
	
	n1:
	mov [esi], edx
	add esi, 4
	dec edi
	jnz n1
	add ebx, ecx
	mov esi, ebx
	mov edi, eax
	dec ebp
	jnz n1

	pop ebp
	pop ebx
	pop edi
	pop esi
	ret 20
FillRectangle ENDP
; ---------------------------------------------------------
align 4
HorLine PROC x:DWORD, ilen:DWORD, y:DWORD, farge:DWORD
	push esi
	push edi
	push ebx
	mov eax, y
	mov edx, SCREEN_WIDTH*4
	mov ebx, x
	mov esi, farge
	mov edi, bitdataptr
	mul edx
	shl ebx, 2
	mov ecx, ilen
	add edi, eax
	mov eax, esi
	add edi, ebx
	rep stosd
	pop ebx
	pop edi
	pop esi
	ret
HorLine ENDP
; ---------------------------------------------------------
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef


DrawRandomPixels PROC iCount:DWORD

	; Generate seed
	INVOKE GetTickCount
	INVOKE nseed, eax

	; Generate iCount random pixels
	push esi
	push edi
	push ebx
	mov esi, SCREEN_WIDTH
	mov edi, bitdataptr
	mov ecx, iCount
	@@:push ecx
	INVOKE nrandom, SCREEN_WIDTH
	mov ebx, eax
	INVOKE nrandom, SCREEN_HEIGHT
	mov ecx, ebx
	mov ebx, 0FF00FF00h
; ecx = x	eax = y		ebx = color	esi = ScrWidth		edi = bitdataptr
	INVOKE PlotPixelRA

	pop ecx
	dec ecx
	jnz @B
	
	pop ebx
	pop edi
	pop esi
	ret
	
DrawRandomPixels ENDP


PixelThread PROC lpParameter:LPVOID
	
WaitAgain:
	; Claim critical section
	;------------------------
	INVOKE EnterCriticalSection, OFFSET RenderCritical
	mov eax, GracefulTermination
	test eax, eax
	jz WeAreAlive
	ret

WeAreAlive:

	; Clear screen first
	ClrDib bitdataptr, 0FF000000h, eax

	; Draw Random pixels
	INVOKE DrawRandomPixels, PIXEL_COUNT

	; Leave critical section
	;-------------------------
	INVOKE LeaveCriticalSection, OFFSET RenderCritical
	
	; Invalidate screen and update our newly moved pixels
	INVOKE InvalidateRect, lpParameter, 0, 0

	; go back again
	jmp WaitAgain
	
PixelThread ENDP


end Start

