
;----------------------------------------------------------------------------------------
;					WM_CREATE
;----------------------------------------------------------------------------------------

	; Create critical section to prevent excessive WM_PAINTS drawing in the middle of pixel processing which will result in tearing
	;-------------------------------------------------------------------------------------------------------------------------------
	INVOKE InitializeCriticalSectionAndSpinCount, OFFSET RenderCritical, 1024

	; Get our own dc for window
	;--------------------------
	INVOKE GetDC, hWnd
	mov hDC, eax
	
	; Create mem dc
	;---------------
	INVOKE CreateCompatibleDC, eax
	mov memDC, eax
	
	; Release DC again
	;------------------
	INVOKE ReleaseDC, hWnd, hDC
	
	; Create DIB Section that we will do our drawing on
	;---------------------------------------------------
	INVOKE CreateCompatibleDibSection, hDC, OFFSET bitdataptr
	mov dibhandle, eax
	
	; Select new bitmap into memDC
	;------------------------------
	INVOKE SelectObject, memDC, dibhandle
	mov OldObject, eax

	; Create thread for handling pixels
	;----------------------------------
	INVOKE CreateThread, NULL, 0, OFFSET PixelThread, hWnd, 0, 0
	mov ThreadHandle, eax

