
;----------------------------------------------------------------------------------------
;				WM_DESTROY
;----------------------------------------------------------------------------------------

	; Gracefully shutdown pixel thread and close the handle (Must be done before destroying GDI objects)
	;----------------------------------------------------------------------------------------------------
	mov GracefulTermination, 1
	INVOKE WaitForSingleObject, ThreadHandle, THREAD_TIMEOUT_DELAY
	INVOKE CloseHandle, ThreadHandle

	; Delete critical section used by the pixel-thread
	;--------------------------------------------------
	INVOKE DeleteCriticalSection, OFFSET RenderCritical
	
	; Free Objects
	;-------------------------------------
	INVOKE SelectObject, memDC, OldObject
	INVOKE DeleteObject, dibhandle
	INVOKE DeleteDC, memDC

	; Put WM_QUIT in message loop to indicate we're quitting
	;-------------------------------------------------------
	INVOKE PostQuitMessage, NULL
